100 CT = 0
200 CLS
300 GOSUB 15100   'Put up format screen
400 INPUT "Type 'e' to exit or any character to continue; press ENTER ",DN1$
500 CLS
600 IF DN1$<>"e" THEN 800  'End if char. "e" entered
700 END
800 INPUT "Type trace filename; press ENTER ",DN$
900 INPUT "Type 'd' for display or anything else for print; press ENTER ",OP$
1000 OPEN "I",#1,DN$
1100 THB1$ = INPUT$(1,#1)   'Get first byte of MU header
1200 IF EOF(1) THEN 17500
1300 THB2$ = INPUT$(1,#1)   'Get 2nd byte of MU header
1400 IF EOF(1) THEN 17500
1500 ITHB2 = ASC(THB2$)     'Convert to interger
1600 L1$ = "                                                               "
1700 ITHB1 = ASC(THB1$)
1800 IF (ITHB1 AND &H1) <> 0 THEN ITHB2 = ITHB2 + 256  'Add 256 to PIU if bit 0 of first mu header byte is on
1900 IF ITHB2=0 THEN 12600  'End Of File if MU length 0
2000 IF ITHB1=26 THEN 12600  'End Of File if EOF character
2100 SRM = ITHB1 AND &H80   'Send/Recv bit
2200 TRUN = ITHB1 AND &H40  'Truncate bit
2300 LOST = ITHB1 AND &H20   'Data lost bit
2400 IF SRM=0 THEN MID$(L1$,1,1)="S" ELSE MID$(L1$,1,1)="R"
2500 IF TRUN<>0 THEN MID$(L1$,3,1) = "T"
2600 IF LOST<>0 THEN MID$(L1$,5,1) = "L"
2700 N = 33
2800 J = 6
2900 FOR I=1 TO J    'Process TH
3000 GOSUB 13100
3100 IF I <> 1 THEN 3300
3200 SG = AI AND &H8   'Check for segmented RU
3300 IF (ITHB2=26) AND (AI=26) AND (I=1) THEN 12600   'Another test for EOF
3400 MID$(L1$,N,1) = HB$
3500 N = N+1
3600 MID$(L1$,N,1) = LB$
3700 N = N+2
3800 NEXT I
3900 IF SG<>0 THEN 4400     'If TH indicates segmented RU, Then
4000 MID$(L1$,8,2)="FM"     'Assume RU is FM data without RH
4100 MID$(L1$,13,2)="RQ"
4200 ITHB2 = ITHB2-6
4300 GOTO 10200
4400 GOSUB 13100            'Else get and process RH
4500 NRSP = AI AND &H4
4600 RUC = AI AND &H60   'Determine RU category
4700 IF RUC = 0 THEN MID$(L1$,8,2)="FM"
4800 IF RUC = 32 THEN MID$(L1$,8,2)="NC"
4900 IF RUC = 64 THEN MID$(L1$,8,3)="DFC"
5000 IF RUC = 96 THEN MID$(L1$,8,2)="SC"
5100 RQSP = AI AND &H80   'Determine Req. or Rsp.
5200 IF RQSP=0 THEN MID$(L1$,13,2) = "RQ": GOTO 5400
5300 IF NRSP=0 THEN MID$(L1$,13,3)="RSP" ELSE MID$(L1$,13,4)="NRSP"
5400 N = 54
5500 GOSUB 14500
5600 J=2
5700 FOR I=1 TO J   'Process remainder of RH
5800 GOSUB 13100
5900 GOSUB 14500
6000 NEXT I
6100 AI = AI AND &H20
6200 IF (RQSP=0) AND (AI<>0) THEN MID$(L1$,19,2)="CD"  'Check for CD
6300 RUC = RUC AND &H40
6400 J = 23
6500 RU$ = "   "
6600 IF ITHB2=9 THEN ITHB2=0: GOTO 10200    'MU without RU data
6700 IF (RQSP<>0) AND (NRSP<>0) AND (RUC<>0) THEN 7400  'If not NRSP
6800 GOSUB 13100   'Get 1st byte of RU (command)
6900 MID$(RU$,1,1) = HB$
7000 MID$(RU$,2,1) = LB$
7100 ITHB2 = ITHB2-10
7200 IF RUC=0 THEN 10200  'Do not check for cmd. type if FM data RU
7300 GOTO 8600
7400 J = 5      'Negative response (4 bytes sense data followed by cmd. type)
7500 N = 1
7600 RU$ = "               "
7700 FOR I=1 TO J   'Process RU data up thru cmd. type
7800 GOSUB 13100
7900 MID$(RU$,N,1) = HB$
8000 N = N+1
8100 MID$(RU$,N,1) = LB$
8200 N = N+2
8300 NEXT I
8400 ITHB2 = ITHB2-14   'Update unprocessed MU length
8500 J = 19   'Determine command type
8600 IF AI=4 THEN MID$(L1$,23,6)="LUSTAT": GOTO 10200
8700 IF AI=5 THEN MID$(L1$,23,3)="RTR": GOTO 10200
8800 IF AI=13 THEN MID$(L1$,23,5)="ACTLU": GOTO 10200
8900 IF AI=14 THEN MID$(L1$,23,6)="DACTLU": GOTO 10200
9000 IF AI=17 THEN MID$(L1$,23,5)="ACTPU": GOTO 10200
9100 IF AI=18 THEN MID$(L1$,23,6)="DACTPU": GOTO 10200
9200 IF AI=49 THEN MID$(L1$,23,4)="BIND": GOTO 10200
9300 IF AI=50 THEN MID$(L1$,23,6)="UNBIND": GOTO 10200
9400 IF AI=131 THEN MID$(L1$,23,6)="CANCEL": GOTO 10200
9500 IF AI=132 THEN MID$(L1$,23,5)="CHASE": GOTO 10200
9600 IF AI=160 THEN MID$(L1$,23,3)="SDT": GOTO 10200
9700 IF AI=161 THEN MID$(L1$,23,5)="CLEAR": GOTO 10200
9800 IF AI=192 THEN MID$(L1$,23,5)="SHUTD": GOTO 10200
9900 IF AI=193 THEN MID$(L1$,23,5)="SHUTC": GOTO 10200
10000 IF AI=200 THEN MID$(L1$,23,3)="BID": GOTO 10200
10100 IF AI=201 THEN MID$(L1$,23,6)="SIGNAL"
10200 IF OP$="d" THEN PRINT L1$ ELSE LPRINT L1$  'Print first line of MU
10300 CT = CT+1
10400 IF CT=23 THEN GOSUB 14000   'Check for screen full
10500 IF SG=0 THEN 12000   'If MU middle or last of segment then skip over special handling done for first line of RU data
10600 IF OP$="d" THEN PRINT SPC(4);RU$; ELSE LPRINT SPC(4);RU$; 'PRINT COMMAND PORTION OF RU DATA
10700 IF ITHB2<=J THEN J=ITHB2   'Get number of bytes for this line
10800 IF ITHB2<=J THEN ITHB2=0 ELSE ITHB2=ITHB2-J  'Update unprocessed MU lngth
10900 IF J=0 THEN 12200
11000 GOTO 11300   'Skip over process loop if no more data
11100 IF ITHB2<25 THEN J=ITHB2 ELSE J=24  'Get number of bytes for this line
11200 IF ITHB2<25 THEN ITHB2=0 ELSE ITHB2=ITHB2-24  'Update MU length
11300 FOR I=1 TO J   'Loop to process a line of RU data
11400 GOSUB 13100
11500 IF OP$="d" THEN PRINT HB$;LB$;" "; ELSE LPRINT HB$;LB$;" ";
11600 NEXT I
11700 IF OP$="d" THEN PRINT " " ELSE LPRINT " "  'End of line
11800 CT = CT+1
11900 IF CT=23 THEN GOSUB 14000  'Test for screen full
12000 IF OP$="d" THEN PRINT SPC(4); ELSE LPRINT SPC(4);   'Indent level
12100 IF ITHB2>0 THEN 11100  'End of RU
12200 IF OP$="d" THEN PRINT " " ELSE LPRINT " "  'Blank line between MUs
12300 CT = CT+1
12400 IF CT=23 THEN GOSUB 14000  'Check for screen full
12500 GOTO 1100
12600 CLOSE #1
12700 CT = 0
12800 IF OP$="d" THEN PRINT "End of file" ELSE LPRINT "End of file"
12900 GOTO 400  'Process another MU
13000 REM ** convert to hex routine
13100 A$ = INPUT$(1,#1)
13200 IF EOF(1) THEN 17500
13300 AI = ASC(A$)
13400 AHX$ = HEX$(AI)
13500 IF LEN(AHX$)=1 THEN HB$="0": GOTO 13700
13600 HB$ = LEFT$(AHX$,1)
13700 LB$ = RIGHT$(AHX$,1)
13800 RETURN
13900 REM ** prompt to continue **
14000 IF OP$<>"d" THEN 14200
14100 INPUT "Press ENTER to continue",DMY$
14200 CT = 0
14300 RETURN
14400 REM ** process RH **
14500 MID$(L1$,N,1) = HB$
14600 N = N+1
14700 MID$(L1$,N,1) = LB$
14800 N = N+2
14900 RETURN
15000 REM ** MENU **
15100 PRINT SPC(20);"PC NETWORK 3270 PIU Trace Print Format"
15200 PRINT " "
15300 PRINT " "
15400 PRINT " Send/Receive indicator"
15500 PRINT "  Indicates this PIU was truncated"
15600 PRINT "   Indicates that trace data prior to this was lost"
15700 PRINT "       RU category"
15800 PRINT "           Request/Response/Negative Response indication"
15900 PRINT "               Change Direction indicator"
16000 PRINT "                    Command type from RU (not all printed)"
16100 PRINT "                                   Transmission Header"
16200 PRINT "                                                  Req./Resp. Header"
16300 PRINT "                                                 "
16400 PRINT "     Ŀ  Ŀ  ڿ  Ŀ    Ŀ    Ŀ"
16500 PRINT " "
16600 PRINT "c c c   ccc  cccc  cc  cccccc    nn nn nn nn nn nn    nn nn nn"
16700 PRINT "    nn nn nn nn nn nn nn nn nn nn ---/ /----- nn nn nn nn nn nn nn nn nn nn"
16800 PRINT " "
16900 PRINT "    "
17000 PRINT "                                  "
17100 PRINT "                                   Request/Response Unit"
17200 PRINT " "
17300 PRINT " "
17400 RETURN
17500 REM ** EOF MESSAGE **
17600 PRINT " "
17700 PRINT " "
17800 PRINT "ASCII End Of File (HEX 1A) detected in trace, cannot continue."
17900 PRINT " "
18000 GOTO 400
